#include <bits/stdc++.h>

using namespace std;

typedef long long ll;


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    vector<int> c(n);
    for (int i=0; i<n; i++){
        if (s[i]=='?'){
            c[i]=-1;
        }
        else{
            c[i]=s[i]-'0';
        }
    }
    for (int t=0; t<q; t++){
        int L,D;
        cin >> L >> D;
        int raz=D-L+1;
        cout << (raz/2)*((raz/2)+raz%2) << endl;
    }


    return 0;
}